﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace erettsegi10_Lift
{
    
    class erettsegi10_Lift
    {
        struct Igény
        {
            public TimeSpan idő;
            public int csapat, honnan, hová;
        }

        static void Main()
        {
            #region 1. feladat: Az adatok beolvasása, adatszerkezet feltöltése
            Console.WriteLine("\n1. Feladat: Adatok olvasása, adatszerkezet feltöltése");
            List<Igény> igények = new List<Igény>();
            int szintszám;
            int csapatszám;
            int igényszám;
            using (StreamReader sr = new StreamReader("igeny.txt"))
            {
                szintszám = int.Parse(sr.ReadLine());
                csapatszám = int.Parse(sr.ReadLine());
                igényszám = int.Parse(sr.ReadLine());
                for (int i = 0; i < igényszám; i++)
                {
                    string[] fields = sr.ReadLine().Split(' ');
                    Igény új_igény  = new Igény()
                    {
                        idő = TimeSpan.Parse(fields[0] + ':' + fields[1] +':'+ fields[2]),
                        csapat = int.Parse(fields[3]),
                        honnan = int.Parse(fields[4]),
                        hová = int.Parse(fields[5]),
                    };
                    igények.Add(új_igény);
                }
            }
            #endregion

            #region 2. feladat: Hol áll a lift 9h-kor?
            Console.WriteLine("\n2. Feladat: Hol áll a lift 9h-kor?");
           
            Console.Write("Adja meg, hogy melyik szinten van a lift:");
            int indulószint = int.Parse(Console.ReadLine());
            #endregion

            #region 3. feladat: Hol fejezi be a lift?
            Console.WriteLine("\n3. Feladat: Hol fejezi be a lift?");
            Console.WriteLine("A lift a {0}. szinten áll az utolsó igény teljesítése után.", igények.Last().hová);
            #endregion

            #region 4. feladat: Minimum, maximum
            Console.WriteLine("\n4. Feladat: Minimum, maximum");
            Console.WriteLine("Legmagasabb szint:{0}, Legalacsonyabb:{1}",
            igények.Max(i => Math.Max(i.hová,i.honnan)), igények.Min(i => Math.Min(i.hová, i.honnan)));
            #endregion

            #region 5. feladat: Felfelé utassal és üresen
            Console.WriteLine("\n5. Feladat: Felfelé utassal és üresen");
            int előzőszint = indulószint;
            int utas_nélkül=0;
            foreach (var i in igények)
            {
                if (i.honnan > előzőszint) utas_nélkül++;
                előzőszint = i.hová;
            }
            Console.WriteLine("Utassal= {0} üresen= {1}", igények.Count(i => i.hová > i.honnan), utas_nélkül);
            #endregion

            #region 6. feladat: Nem liftező szerelőcsapatok
            Console.Write("\n6. Feladat: Nem liftező szerelőcsapatok:");
            for (int i = 1; i <= csapatszám; i++)
                if (igények.Count(j => j.csapat == i) == 0) Console.Write("{0}. ", i);
            #endregion

            #region 7. feladat: Szabálytalan-e a kiválasztott csapat?
            Console.WriteLine("\n7. Feladat: Szabálytalan-e a kiválasztott csapat?");

            Random r = new Random();
            int vél_csapat = r.Next(csapatszám) + 1;
            //vél_csapat = 12; //Teszthez, ez a csapat 2x is csalt

            if (igények.Count(cs => cs.csapat == vél_csapat) > 1) //volt-e elegendő igény?
            {
                var vél_igények = from i in igények
                                  where i.csapat == vél_csapat
                                  select i;

                var előző = vél_igények.First();
                előző.hová = előző.honnan; //mivel nem tudjuk, hogy hol volt a csapat 9h előtt
                bool csaltak = false;
                foreach (var i in vél_igények)
                {
                    if (i.honnan != előző.hová)
                    {
                        Console.WriteLine("A(z) {0}. csapat gyalogolt a(z) {1}. és {2}. szintek  között!",
                                        vél_csapat, előző.hová, i.honnan);
                        csaltak = true;
                    }
                    előző = i;
                }
                if (!csaltak) Console.WriteLine("Nem bizonyítható szabálytalanság a(z) {0}. csapatnál.", vél_csapat);
            }else Console.WriteLine("Nem bizonyítható szabálytalanság a(z) {0}. csapatnál (kevés /0-1/ igény)", vél_csapat);
            #endregion

            #region 8. feladat: blokkol.txt
            Console.WriteLine("\n8. Feladat: blokkol.txt kiírása");

            using (StreamWriter sw = new StreamWriter("blokkol.txt"))
            {
                foreach (var i in igények)
                {
                    if (i.csapat == vél_csapat)
                    {
                        Console.WriteLine("Befejezés ideje: {0}",i.idő);
                        Console.Write("Sikeresség="); string sikeresség = Console.ReadLine();
                        Console.WriteLine("-----"); 
                        Console.WriteLine("Indulási emelelet: {0}", i.honnan);
                        Console.WriteLine("Célemelet: {0}", + i.hová);
                        Console.Write("Feladatkód=");
                        int feladatkód = int.Parse(Console.ReadLine());

                        sw.WriteLine("Befejezés ideje: {0}", i.idő);
                        sw.WriteLine("Sikeresség: {0}", sikeresség);
                        sw.WriteLine("-----");
                        sw.WriteLine("Indulási emelelet: {0}", i.honnan);
                        sw.WriteLine("Célemelet: {0}", i.hová);
                        sw.WriteLine("Feladatkód: {0}", feladatkód);
                    }
                }
            }
            #endregion

            Console.ReadKey();
        }
    }
}
